/*
 *  Classified Tydeman Consulting Proprietary
 *  Copyright (C) 2005, 2014 Tydeman Consulting.  All rights reserved.
 *
 *  Fred J. Tydeman	tydeman@tybor.com
 *
 * - -- --- ---- ----- -------------------------------------------------
 *
 *    This code is copyrighted.  Under the copyright laws, this code may
 *         not be copied, in whole or part, without prior written
 *         consent of Tydeman Consulting.
 *
 *    RESTRICTED RIGHTS LEGEND: Use, duplication, or disclosure by the
 *         government is subject to restrictions as set forth in
 *         subparagraph (c)(1)(ii) of the Rights in Technical Data and
 *         Computer Software clause at DFARS 252.227-7013 and
 *         FAR 52.227-19.
 *
 * - -- --- ---- ----- -------------------------------------------------
 * $Revision: 2.1 $
 ***********************************************************************
 *  FILE: fpconoff.h
 *
 *  Description:  Do the different forms of FP CONTRACT OFF, including 
 *  compiler specific ones.  See writeup in mydefs.h just before 
 *  #include "fpconoff.h" for why so many forms.
 *
 *  MODIFICATION HISTORY:
 *
 * 2005/05/08 - Create from mydefs.h and myfloat.h
 * 2005/05/08 - Update DEBUG section.
 * 2008/07/14 - Shorten marco symbols to less than 32 chars.
 * 2014/06/19 - Redo Microsoft stuff.
 *
 ***********************************************************************/

/*lint -efile(766,fpconoff.h) // header file "not" used */

#ifdef DEBUG	/* local override of FIXes to force errors to show */
  #ifdef DEBUG2	/* Kills some compilers */
  #endif
  #ifdef DEBUG3
  #endif
  #undef  FIX_PRAGMAS
  #undef  FIX_PRAGMA_CONTRACT
#endif

#if (!defined FIX_PRAGMAS)
  #if (!defined FIX_PRAGMA_CONTRACT) && (!defined LMS_NO_CONTRACT)
    #if (19970207uL <= FPCE_TEST_LVL)
      #pragma STDC FP_CONTRACT OFF
    #else
      #pragma fp_contract off
    #endif
    #ifdef FP_CONTRACT_OFF	/* Want 'standard' IEEE behaviour */
	 FP_CONTRACT_OFF
    #endif
  #endif
  #ifdef _IBMR2			/* IBM xlc specific */
    #pragma options NOMAF
  #endif
  #ifdef _MSC_VER		/* Microsoft Visual Studio specific */
    #pragma fp_contract(off)
  #endif
#endif
