/*
 *  Classified Tydeman Consulting Proprietary
 *  Copyright (C) 2014, 2020 Tydeman Consulting.  All rights reserved.
 *
 *  Fred J. Tydeman	tydeman@tybor.com
 *
 * - -- --- ---- ----- -------------------------------------------------
 *
 *    This code is copyrighted.  Under the copyright laws, this code may
 *         not be copied, in whole or part, without prior written
 *         consent of Tydeman Consulting.
 *
 *    RESTRICTED RIGHTS LEGEND: Use, duplication, or disclosure by the
 *         government is subject to restrictions as set forth in
 *         subparagraph (c)(1)(ii) of the Rights in Technical Data and
 *         Computer Software clause at DFARS 252.227-7013 and
 *         FAR 52.227-19.
 *
 * - -- --- ---- ----- -------------------------------------------------
 * $Revision: 2.1 $
 ***********************************************************************
 *  FILE: vpatch.h
 *
 * Following is used by almost all v1nn*.h test vector files (real
 * and cmplx) via the corresponding g1nn*.h file.  It is needed for
 * compilers that cannot initialize [static] array elements to
 * expressions.
 *
 *  MODIFICATION HISTORY:
 *
 * 2014/08/05 - Create.
 * 2014/10/05 - Update DEBUG section.
 * 2014/12/24 - Move SIZE() to mydefs.h.
 * 2020/09/25 - Add FIX_SMALLER_THAN_FPMIN to DEN_EXP().
 *
 ***********************************************************************/

#ifdef DEBUG	/* local override of FIXes to force errors to show */
  #ifdef DEBUG2	/* Kills some compilers */
    #undef  FIX_CONST_EXP_IN_INIT
    #undef  FIX_FP_EXP_IN_INIT
    #undef  FIX_INF10_IN_ARRAY
    #undef  FIX_INF_IN_ARRAY
    #undef  FIX_NAN10_IN_ARRAY
    #undef  FIX_NAN_IN_ARRAY
    #undef  FIX_SMALLER_THAN_FPMIN
    #undef  FIX_STATIC_INF
    #undef  FIX_STATIC_INF10
    #undef  FIX_STATIC_NAN
    #undef  FIX_STATIC_NAN10
    #undef  LMS_USING_DEN_EXP
    #undef  LMS_USING_FP_EXP
  #endif
#endif

#ifdef DEBUG	/* local override of FIXes to force errors to show */
  #ifdef DEBUG3
/*  #undef  D10_PREC */
/*  #undef  DFP_TEST_LVL */
/*  #undef  D_PREC */
/*  #undef  F10_PREC */
/*  #undef  FIX_BAD_FAKE_DECFP */
/*  #undef  FPCE_TEST_LVL */
/*  #undef  F_PREC */
/*  #undef  LD10_PREC */
/*  #undef  LD_PREC */
  #endif
  #undef  FIX_BAD_OPT
  #undef  FIX_CLOSE_MINp1_D10
  #undef  FIX_CLOSE_MINp1_DBL
  #undef  FIX_CLOSE_MINp1_F10
  #undef  FIX_CLOSE_MINp1_FLT
  #undef  FIX_CLOSE_MINp1_LD10
  #undef  FIX_CLOSE_MINp1_LDBL
  #undef  FIX_CLOSE_MIN_D10
  #undef  FIX_CLOSE_MIN_DBL
  #undef  FIX_CLOSE_MIN_F10
  #undef  FIX_CLOSE_MIN_FLT
  #undef  FIX_CLOSE_MIN_LD10
  #undef  FIX_CLOSE_MIN_LDBL
  #undef  FIX_CLOSE_ONEm1_DBL
  #undef  FIX_CLOSE_ONEm1_FLT
  #undef  FIX_CLOSE_ONEm1_LDBL
  #undef  FIX_CLOSE_ONEp1_DBL
  #undef  FIX_CLOSE_ONEp1_FLT
  #undef  FIX_CLOSE_ONEp1_LDBL
  #undef  FIX_DEC2BIN_ZERO
  #undef  FIX_DEC2DFP_ZERO
  #undef  FIX_DENORM_TWO
  #undef  FIX_FLUSH_FINAL_DENORM
  #undef  FIX_FLUSH_HEX_DENORM
  #undef  FIX_FLUSH_RUN_DEN_BOTH
  #undef  FIX_MIN_LDBL
  #undef  FIX_M_PSEUDO_INFINITY
  #undef  FIX_ONEm1_LD10_IN_ARRAY
  #undef  FIX_ONEm1_LDBL_IN_ARRAY
  #undef  FIX_ONEp1_LD10_IN_ARRAY
  #undef  FIX_ONEp1_LDBL_IN_ARRAY
  #undef  FIX_PSEUDO_DENORMALS
  #undef  FIX_PSEUDO_INFINITY
  #undef  FIX_SLOPPY_CONSTANT_EXP
  #undef  FIX_STATIC_ONEm1_LD10
  #undef  FIX_STATIC_ONEm1_LDBL
  #undef  FIX_STATIC_ONEp1_LD10
  #undef  FIX_STATIC_ONEp1_LDBL
  #undef  FIX_WRONG_MINp1_D10
  #undef  FIX_WRONG_MINp1_DBL
  #undef  FIX_WRONG_MINp1_F10
  #undef  FIX_WRONG_MINp1_FLT
  #undef  FIX_WRONG_MINp1_LD10
  #undef  FIX_WRONG_MINp1_LDBL
  #undef  FIX_WRONG_MIN_D10
  #undef  FIX_WRONG_MIN_DBL
  #undef  FIX_WRONG_MIN_F10
  #undef  FIX_WRONG_MIN_FLT
  #undef  FIX_WRONG_MIN_LD10
  #undef  FIX_WRONG_MIN_LDBL
  #undef  FIX_WRONG_ONEm1_DBL
  #undef  FIX_WRONG_ONEm1_FLT
  #undef  FIX_WRONG_ONEm1_LDBL
  #undef  FIX_WRONG_ONEp1_DBL
  #undef  FIX_WRONG_ONEp1_FLT
  #undef  FIX_WRONG_ONEp1_LDBL
#endif

#ifndef   VPATCH_H_
  #define VPATCH_H_

  #define PATCH FPK(124816.)

  #if (defined FIX_FLUSH_RUN_DEN_BOTH)
    #define PATCHDEN ZERO_q
  #else
    #define PATCHDEN PATCH
  #endif

  #if (defined FIX_FP_EXP_IN_INIT) \
   || (defined FIX_CONST_EXP_IN_INIT) \
   || (defined FIX_SLOPPY_CONSTANT_EXP)
    #define LMS_USING_FP_EXP
    #define FP_EXP(x) PATCH
  #else
    #define FP_EXP(x) (x)
  #endif

  /*
   * Expression using or computing a denormal FP number.
   */
  #if (defined FIX_FP_EXP_IN_INIT) \
   || (defined FIX_CONST_EXP_IN_INIT) \
   || (defined FIX_SLOPPY_CONSTANT_EXP) \
   || (defined FIX_DEC2BIN_ZERO) \
   || (defined FIX_DEC2DFP_ZERO) \
   || (defined FIX_FLUSH_HEX_DENORM) \
   || (defined FIX_FLUSH_FINAL_DENORM) \
   || (defined FIX_DENORM_TWO) \
   || (defined FIX_PSEUDO_DENORMALS) \
   || (defined FIX_SMALLER_THAN_FPMIN)
    #define LMS_USING_DEN_EXP
    #define DEN_EXP(x) PATCHDEN
  #else
    #define DEN_EXP(x) (x)
  #endif

  #if (((defined FIX_NAN_IN_ARRAY  )||(defined FIX_STATIC_NAN  )) && ( 2==FP_RADIX)) \
   || (((defined FIX_NAN10_IN_ARRAY)||(defined FIX_STATIC_NAN10)) && (10==FP_RADIX))
    #define LMS_NAN_Q_IS_ZERO
    #define NAN_Q PATCH
  #else
    #define NAN_Q NAN_q
  #endif

  #if (((defined FIX_INF_IN_ARRAY  )||(defined FIX_STATIC_INF  )) && ( 2==FP_RADIX)) \
   || (((defined FIX_INF10_IN_ARRAY)||(defined FIX_STATIC_INF10)) && (10==FP_RADIX)) \
   ||   (defined FIX_PSEUDO_INFINITY) \
   ||   (defined FIX_M_PSEUDO_INFINITY)
    #define LMS_INF_Q_IS_ZERO
    #define INF_Q PATCH
  #else
    #define INF_Q INF_q
  #endif

  #if (defined FIX_WRONG_ONEp1_FLT) \
   || (defined FIX_WRONG_ONEp1_DBL) \
   || (defined FIX_WRONG_ONEp1_LDBL)
    #error Try expression like (ONE_type + ULP_type) in your *.flt file.
  #endif

  #if ((PREC_q ==  LD_PREC) && (defined FIX_ONEp1_LDBL_IN_ARRAY)) \
   || ((PREC_q ==  LD_PREC) && (defined FIX_STATIC_ONEp1_LDBL  )) \
   || ((PREC_q ==LD10_PREC) && (defined FIX_ONEp1_LD10_IN_ARRAY)) \
   || ((PREC_q ==LD10_PREC) && (defined FIX_STATIC_ONEp1_LD10  )) \
   || ((PREC_q ==   F_PREC) && (defined FIX_CLOSE_ONEp1_FLT)) \
   || ((PREC_q ==   D_PREC) && (defined FIX_CLOSE_ONEp1_DBL)) \
   || ((PREC_q ==  LD_PREC) && (defined FIX_CLOSE_ONEp1_LDBL)) \
   || ((defined FIX_BAD_FAKE_DECFP) && (10 == FP_RADIX))
    #define LMS_ONEp1_Q_IS_ZERO
    #define ONEp1_Q PATCH
  #else
    #define ONEp1_Q ONEp1_q
  #endif

  #if (defined FIX_WRONG_ONEm1_FLT) \
   || (defined FIX_WRONG_ONEm1_DBL) \
   || (defined FIX_WRONG_ONEm1_LDBL)
    #error Try expression like (ONE_type - ULP_type/TWO_type) in your *.flt file.
  #endif

  #if ((PREC_q ==  LD_PREC) && (defined FIX_ONEm1_LDBL_IN_ARRAY)) \
   || ((PREC_q ==  LD_PREC) && (defined FIX_STATIC_ONEm1_LDBL  )) \
   || ((PREC_q ==LD10_PREC) && (defined FIX_ONEm1_LD10_IN_ARRAY)) \
   || ((PREC_q ==LD10_PREC) && (defined FIX_STATIC_ONEm1_LD10  )) \
   || ((PREC_q ==   F_PREC) && (defined FIX_CLOSE_ONEm1_FLT)) \
   || ((PREC_q ==   D_PREC) && (defined FIX_CLOSE_ONEm1_DBL)) \
   || ((PREC_q ==  LD_PREC) && (defined FIX_CLOSE_ONEm1_LDBL)) \
   || ((defined FIX_BAD_FAKE_DECFP) && (10 == FP_RADIX))
    #define LMS_ONEm1_Q_IS_ZERO
    #define ONEm1_Q PATCH
  #else
    #define ONEm1_Q ONEm1_q
  #endif

  #if (defined LMS_USING_FP_EXP) \
   || ((PREC_q ==   F_PREC) && ((defined FIX_CLOSE_MINp1_FLT) || (defined FIX_WRONG_MINp1_FLT ))) \
   || ((PREC_q ==   D_PREC) && ((defined FIX_CLOSE_MINp1_DBL) || (defined FIX_WRONG_MINp1_DBL ))) \
   || ((PREC_q ==  LD_PREC) && ((defined FIX_CLOSE_MINp1_LDBL)|| (defined FIX_WRONG_MINp1_LDBL))) \
   || ((PREC_q == F10_PREC) && ((defined FIX_CLOSE_MINp1_F10) || (defined FIX_WRONG_MINp1_F10 ))) \
   || ((PREC_q == D10_PREC) && ((defined FIX_CLOSE_MINp1_D10) || (defined FIX_WRONG_MINp1_D10 ))) \
   || ((PREC_q ==LD10_PREC) && ((defined FIX_CLOSE_MINp1_LD10)|| (defined FIX_WRONG_MINp1_LD10)))
    #define LMS_MINp1_Q_IS_ZERO
    #define MINp1_Q PATCH
  #elif (defined LMS_USING_DEN_EXP) \
     || (defined FIX_DEC2BIN_ZERO) \
     || (defined FIX_DEC2DFP_ZERO) \
     || (defined FIX_FLUSH_HEX_DENORM) \
     || (defined FIX_DENORM_TWO) \
     || (defined FIX_PSEUDO_DENORMALS)
    #define MINp1_Q FP_EXP(MIN_q*ONEp1_q)
  #else
    #define MINp1_Q DEN_EXP(MIN_q+DEN_q)
  #endif

  #if ((PREC_q ==   F_PREC) && ((defined FIX_CLOSE_MIN_FLT) || (defined FIX_WRONG_MIN_FLT ))) \
   || ((PREC_q ==   D_PREC) && ((defined FIX_CLOSE_MIN_DBL) || (defined FIX_WRONG_MIN_DBL ))) \
   || ((PREC_q ==  LD_PREC) && ((defined FIX_CLOSE_MIN_LDBL)|| (defined FIX_WRONG_MIN_LDBL))) \
   || ((PREC_q == F10_PREC) && ((defined FIX_CLOSE_MIN_F10) || (defined FIX_WRONG_MIN_F10 ))) \
   || ((PREC_q == D10_PREC) && ((defined FIX_CLOSE_MIN_D10) || (defined FIX_WRONG_MIN_D10 ))) \
   || ((PREC_q ==LD10_PREC) && ((defined FIX_CLOSE_MIN_LD10)|| (defined FIX_WRONG_MIN_LD10))) \
   || (defined FIX_DENORM_TWO) \
   || (defined FIX_PSEUDO_DENORMALS) \
   || (defined FIX_MIN_LDBL)
    #define LMS_MIN_Q_IS_ZERO
    #define MIN_Q PATCH
  #else
    #define MIN_Q MIN_q
  #endif

  #if (defined LMS_USING_DEN_EXP) \
   || (defined FIX_DEC2BIN_ZERO) \
   || (defined FIX_DEC2DFP_ZERO) \
   || (defined FIX_FLUSH_HEX_DENORM) \
   || (defined FIX_FLUSH_FINAL_DENORM) \
   || (defined FIX_DENORM_TWO) \
   || (defined FIX_PSEUDO_DENORMALS) \
   || (defined FIX_BAD_OPT) \
   || ((defined FIX_BAD_FAKE_DECFP) && (10 == FP_RADIX))
    #define LMS_MINm1_Q_IS_ZERO
    #define LMS_DEN2_Q_IS_ZERO
    #define LMS_DEN_Q_IS_ZERO
    #define MINm1_Q PATCHDEN
    #define DEN2_Q  PATCHDEN
    #define DEN_Q   PATCHDEN
  #else
    #define MINm1_Q DEN_EXP(MIN_q-DEN_q)
    #define DEN2_Q  DEN_EXP(DEN_q+DEN_q)
    #define DEN_Q   DEN_q
  #endif

#endif /* VPATCH_H_ */
